/*
 * Copyright (C) 2004-2019 ZNC, see the NOTICE file for details.
 * Copyright (C) 2019 Jordan "eskimo" Koch me@jordanko.ch
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <znc/Client.h>
#include <znc/Chan.h>
#include <znc/IRCNetwork.h>
#include <znc/Modules.h>

class CRaidMod : public CModule {
  public:
    MODCONSTRUCTOR(CRaidMod) {}

    ~CRaidMod() override {}

    EModRet OnChanMsg(CNick& Nick, CChan& Channel, CString& sMessage) override {
        CIRCNetwork* network = GetNetwork();
        CString myNick = network->GetNick();

        if (sMessage.Contains("u create a queue for ") && !sMessage.Contains(myNick) && Nick.GetNick() == "brobot") {
            PutIRC("PRIVMSG " + Channel.GetName() + " :.raid");
            PutIRC("PRIVMSG " + Channel.GetName() + " :.adv");
        }
        return CONTINUE;
    }
};

template <>
void TModInfo<CRaidMod>(CModInfo& Info) {
    Info.SetWikiPage("raid");
    Info.AddType(CModInfo::NetworkModule);
    Info.SetHasArgs(false);
}

USERMODULEDEFS(CRaidMod, t_s("Reply to .raid automatically"))